#lang racket

;;;; 9. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 19.4.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - imperatívne programovanie,
;;;; - metainterpreter programovacieho jazyka LISP.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 2
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 24.4.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define apply-in-underlying-scheme apply)
(require scheme/mpair)

;;; Kapitola. Metainterpreter programovacieho jazyka LISP.

;;; Sekcia. Vyhodnocovanie výrazov v prostredí väzieb.

;;; Podsekcia. Aritmetizácia.

;; Rozlišovacie položky zoznamových konštruktorov.

(define (tagged-list? exp tag)
  (and (pair? exp)
       (equal? (car exp) tag)))

;; Aritmetizácia výrazov (schéma). 

(define (make-<variant> ...) (list '<variant> ...))     ; konštruktor
(define (<variant>? exp) (tagged-list? exp '<variant>)) ; predikát
(define (<variant>-<selector> exp) ...)                 ; selektor(y)
(define (eval-<variant> exp env) ...)                   ; vyhodnocovanie

;;; Podsekcia. Vyhodnocovanie výrazov v prostredí väzieb.

;; Pokyny. Pozri tiež predchadzajúce cvičenie.

;; Operácia my-eval(exp,env) vyhodnotí výraz exp v prostredí väzieb env.

(define (my-eval exp env)
  (cond [(<variant>? exp) (eval-<variant> exp env)]
        [else (error "Unknown expression type -- EVAL" exp)]))

;;; Podsekcia. Operácie nad prostredím väzieb.

;; Základné operácie.

(define the-empty-environment '())
(define (empty-environment? env) (null? env))
(define (enclosing-environment env) (mcdr env))
(define (first-frame env) (mcar env))
(define the-empty-frame '())
(define (binding-value binding) (mcdr binding))

;; Modifikácia prostredia väzieb.

(define (set-first-frame! env frame) (set-mcar! env frame))
(define (set-binding-value! binding val) (set-mcdr! binding val))

;; Rozšírenie prostredia väzieb.

(define (make-environment frame env)
  (mcons frame env))

(define (add-to-frame-let binding frame)
  (mcons (mcons (car binding) (cadr binding)) frame))

(define (add-to-frame-apply var val frame)
  (mcons (mcons var val) frame))

(define (extend-environment-let bindings env)
  (define (loop bindings frame)
    (if (null? bindings)
        (make-environment frame env)
        (loop (cdr bindings) (add-to-frame-let (car bindings) frame))))
  (loop bindings the-empty-frame))

(define (extend-environment-apply vars vals env)
  (define (loop vars vals frame)
    (if (and (null? vars) (null? vals))
        (make-environment frame env)
        (loop (cdr vars) (cdr vals) (add-to-frame-apply (car vars) (car vals) frame))))
  (loop vars vals the-empty-frame))

;; Globálne prostredie väzieb.

(define (make-primitive-procedure proc)
  (list (string->symbol "primitive procedure") proc))

(define frame-of-primitive-procedures
  (mlist
   (mcons 'zero? (make-primitive-procedure zero?))
   (mcons '+ (make-primitive-procedure +))
   (mcons '- (make-primitive-procedure -))
   (mcons '* (make-primitive-procedure *))
   (mcons 'quotient (make-primitive-procedure quotient))
   (mcons 'remainder (make-primitive-procedure remainder))
   (mcons '= (make-primitive-procedure =))
   (mcons '<= (make-primitive-procedure <=))
   (mcons '< (make-primitive-procedure <))
   (mcons '>= (make-primitive-procedure >=))
   (mcons '> (make-primitive-procedure >))
   (mcons '... (make-primitive-procedure undefined))
   (mcons '#t (make-primitive-procedure #t))
   (mcons '#f (make-primitive-procedure #f))
   ))

(define the-global-environment
  (make-environment frame-of-primitive-procedures the-empty-environment))

;;; Podsekcia. Samo vyhodnocujúce sa výrazy.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Premenné.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma if (podmienkové výrazy).

;;; Podsekcia. Špeciálna forma let (priradenie do lokálnej premennej).

;;; Podsekcia. Špeciálna forma set! (priradenie).

;; Konštruktor.

(define (make-assignment variable value) (list 'set! variable value))

;; Predikát.

(define (assignment? exp) ...)

;; Selektor(y).

(define (assignment-variable exp) ...)
(define (assignment-value exp) ...)

;; Vyhodnocovanie.

(define (eval-assignment exp env) ...)
(define (set-variable-value! var val env) ...)

;; Testovanie.

;; (define assignment-environment (extend-environment-let '((x 1)) (extend-environment-let '((y 2)) the-global-environment)))
;; assignment-environment
;; (begin (my-eval '(set! x 11) assignment-environment) assignment-environment)
;; (begin (my-eval '(set! y 22) assignment-environment) assignment-environment)

;;; Podsekcia. Špeciálna forma begin (postupnosť výrazov).

;; Konštruktor.

(define (make-begin seq) (list* 'begin seq))
;; (define (make-begin seq) (cons 'begin seq)) ; alternatívna definícia

;; Predikát(y).

(define (begin? exp) ...)
(define (last-exp? seq) ...)

;; Selektor(y).

(define (begin-actions exp) ...)
(define (first-exp seq) ...)
(define (rest-exps seq) ...)

;; Vyhodnocovanie.

(define (eval-sequence exps env) ...)
(define (eval-begin exp env) ...)

;; Testovanie.

;; (my-eval '(begin 1) the-global-environment)
;; (my-eval '(begin 2 1) the-global-environment)
;; (my-eval '(begin 3 2 1) the-global-environment)

;;; Podsekcia. Špeciálna forma define (definície).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Špeciálna forma lambda (operátor abstrakcie).

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Aplikatívne výrazy.

;; Pokyny. Pozri predchadzajúce cvičenie.

;;; Podsekcia. Programy.

;; Pokyny. Pozri predchadzajúce cvičenie.
